Redmine - Feature #699
OpenlD login
2008-02-20 12:37 - Antonio Tapiador

Status: Closed Start date: 2008-02-20
Priority: Normal Due date:

Assignee: Eric Davis % Done: 100%
Category: Accounts / authentication Estimated time: 0.00 hour
Target version: 0.9.0

Resolution: Fixed

Description

Supporting OpenlD login would facilitate User registration, as well as incorporating collaborators to projects.

Related issues:
Related to Redmine - Feature #1237: Add support for two-factor authentication Closed
Related to Redmine - Feature #35755: Drop OpenlD support Closed

2008-05-14

Associated revisions

Revision 2437 - 2009-02-11 20:06 - Eric Davis
Unpacked OpenlD gem. #699

Revision 2439 - 2009-02-11 20:06 - Eric Davis
Added OpenlD tables. #699

Revision 2440 - 2009-02-11 20:06 - Eric Davis
Added identity_url to User. #699

Revision 2441 - 2009-02-11 20:07 - Eric Davis

Fixed a bug in open_id_authentication, where relative_url_root is defined
on ActionController:AbstractRequest not Base

#699

Revision 2442 - 2009-02-11 20:07 - Eric Davis
Added the ability to login via OpeniD.

e Refactored AccountController#login to use either
password or openid based authentication
¢ Extracted AccountController#successful_authentication
to setup a user's session cookies and redirect
Implemented the start of AccountController#open_id_authentication
which will check with the OpenID server and perform authentication.
Added text field for the OpenlD url to /login
Added identity_url for OpenlD to the user forms.
Added option to login with OpenlD to the register form.
Added a root url route, which is used by the OpenlD plugin

#699

Revision 2444 - 2009-02-11 20:07 - Eric Davis
Adding OpenlD mock and test. #699

Revision 2445 - 2009-02-11 20:07 - Eric Davis
Added tests for the other OpenlID authentication cases. #699

Revision 2446 - 2009-02-11 20:07 - Eric Davis

Added user setup needed based on the system's registration settings
e Copied the register action's chunk of code used to setup the account
based on Setting.self_registration

¢ Extracted method for when onthefly_creation_failed

e Added tests to confirm the behavior

#699

Revision 2447 - 2009-02-11 20:07 - Eric Davis

Refactored common methods out of register and open_id_authenticate
e Extracted register_by_email_activation
e Extracted register_automatically
e Extracted register_manually_by_administrator

#699

Revision 2448 - 2009-02-11 20:07 - Eric Davis

Prevent registration via OpenlD if self registration is off. #699

Revision 2449 - 2009-02-11 20:24 - Eric Davis

Added a system setting for allowing OpenlD logins and registrations

® Defaults to off
¢ |s set in the Administration panel under Authentication

#699

Revision 2450 - 2009-02-11 20:45 - Eric Davis
Added a space so words don't runtogeatherlikethis. #699
Revision 2452 - 2009-02-12 02:32 - Eric Davis
Fixed the bundled ruby-openid gem
e The open_id_authentication plugin will require the gem automatically so
it doesn't need to be added to environment.rb
¢ Changed the version requirement on the open_id_authentication to match
the latest stable version. Rails config.gem looks for a directory named

after that specific version and will not load newer versions.

#699

Revision 2453 - 2009-02-12 05:31 - Eric Davis

Normalize the identity_url when it's set.

Openld uses a specific format for the url it uses which requires the protocol
and trailing slash. This change will normalize the value to when a user sets it.

#699

Revision 2454 - 2009-02-12 18:19 - Jean-Philippe Lang
Hide openid stuff on my account if disabled (#699).

Revision 2455 - 2009-02-12 18:30 - Jean-Philippe Lang
Adds missing strings (#699).

History

#1 - 2008-02-20 13:55 - Michael Pirogov

Read here and here
http://rubyforge.org/forum/message.php?msg_id=38300
http://rubyforge.org/forum/message.php?msg_id=25685

But I'm voting for it too :)

#2 - 2008-02-21 00:19 - Antonio Tapiador

Is there any interest in a path?
| could send it

#3 - 2008-02-21 00:20 - Antonio Tapiador

.. a patch!

#4 - 2008-05-09 21:56 - Stephanie Collett

Is there anymore traction on this? We would like this functionality as well, but would rather not break-away from the codebase.

#5 - 2008-05-15 10:51 - Thomas Lecavelier

Antonio, you should post your patch in the patch tracker: it should interest many people.

#6 - 2008-07-10 07:41 - Antenore Gatta

I would like also to have OpenlD functionality, are there any chances it will be implemented?
Thanks a lot

BR
Antenore.

#7 - 2008-07-16 22:01 - Otto Hilska

I'm also voting for this feature.

#8 - 2008-07-18 12:21 - Jan lvar Beddari

Another vote from me. | come from an enterprise environment where OpenlID could solve SSO for our internal network/intranet in one swoop, using
openid-ldap on top of our existing Active Directory. This will be a lot easier to handle in the long run than integrating each and every app through
apache+kerberos or Idaps.

#9 - 2008-10-10 02:10 - Eric Davis
- Status changed from New to 7

- Assignee set to Eric Davis

I'd like to add OpenlID login and registrations in Redmine. | get several collaborators on my projects and it would make things a lot easier if they could
use OpenlD to signup. I'm hoping to get this into 0.8 but I'm not promising anything yet.

#10 - 2009-02-11 20:35 - Eric Davis
- Status changed from 7 to Resolved
- Target version set to 0.9.0

- % Done changed from 0 to 100

- Resolution set to Fixed

I've added OpenlD support to Redmine. It's optional and by default is turned off. To turn it on, go to the Administration panel > Authentication and
select the OpenlD checkbox. When enabled this will allow users to login through their OpenlID url.

New user registration

If a new user account tries logs in with their OpenlD, the system will create a user for them and then process the account like normal (e.g. needs
administrator approval or needs email confirmation).

Existing users

Existing users can edit their account ('/my/account’) and add their OpenlID to the identity_url field. Then they will be able to login using OpeniD.
Sponser

I'd like to thank Reiner Jung of Keyboard Monkeys for sponsoring this feature. Without him, it would have been awhile before | was able to work on it.

Technical information
e | did some refactoring to AccountController in order to reduce the duplication.

® The openid rubygem is included in vendor/gems

e The open_id_authentication plugin is included in vendor/plugins

¢ We might want to refactor OpenlD to act like an AuthSource later. Right now AuthSources are assumed to be LDAP and since | don't have a
LDAP server to test with | didn't go that route and potentially break LDAP logins.

Commits

Includes commits from r2437 to r2449

#11 - 2009-02-11 21:07 - Go MAEDA

Eric Davis, thanks for your great work.
But it seems that openid rubygem in vendor/gems is not used. | saw the following error while migrating database. It was resolved after | installed
ruby-openid.

$ rake db:migrate
(in /Users/maeda/NetBeansProjects/redmine)
Missing these required gems:

ruby-openid >= 2.0.4

You're running:
ruby 1.8.7.5000 at /usr/local/bin/ruby
rubygems 1.3.1 at /Users/maeda/.gem/ruby/1.8, /usr/local/lib/ruby/gems/1.8

Run "rake gems:install’ to install the missing gems.

My environment:

$ ruby -v
ruby 1.8.7 (2008-11-15 revision 0) [i386-darwin9.5.1]

$ gem list rails
*** LOCAL GEMS ***
rails (2.2.2, 2.1.2, 2.1.1, 2.1.0)

$ svn info

Path:

URL: http://redmine.rubyforge.org/svn/trunk
Repository Root: http://redmine.rubyforge.org/svn
Repository UUID: e93f8b46-1217-0410-a6£0-8£f06a7374b81
Revision: 2450

Node Kind: directory

Schedule: normal

Last Changed Author: edavislO

Last Changed Rev: 2450

Last Changed Date: 2009-02-12 04:45:53 +0900 (0, 12 2 2009)

#12 - 2009-02-12 02:35 - Eric Davis
Go MAEDA wrote:
Eric Davis, thanks for your great work.

But it seems that openid rubygem in vendor/gems is not used. | saw the following error while migrating database. It was resolved after | installed
ruby-openid.

Thanks, can you retry it with r2452? The open_id plugin was trying to load an older version of the gem which wasn't in vendor. | ended up changing
the plugin so it used the bundled gem.

#13 - 2009-02-12 03:44 - Go MAEDA

Eric Davis wrote:

Thanks, can you retry it with r2452? The open_id plugin was trying to load an older version of the gem which wasn't in vendor. | ended up
changing the plugin so it used the bundled gem.

r2452 works fine. Thanks!

#14 - 2009-02-12 09:14 - Jean-Philippe Lang
https://www.redmine.org/projects/redmine/repository/svn/revisions/2437
I'm pretty sad to see that this feature got integrated into the core.
IMHO, it's a marginal feature. Adding dependencies and bundling gems in vendor/plugins doesn't make the application easier to maintain.

That's exactly the kind of thing that I'd like to see implemented as a plugin. Eric, you made a great job on plugins, why didn't you give it a try ? Having
a plugable authentication would be a much better solution.

#15 - 2009-02-12 13:30 - Kevin Menard

For what it's worth, I'm happy to see it in core. While not a Redmine developer, as a user it's great to have this out of the box. One of the problems
I've been running into is that people just don't want to create yet another account on some random Web site (i.e., mine). | actually had a partner on
an open source project opt to go with Lighthouse and Google groups because of the hurdle in creating yet another account on yet another site.

That's not to say that it couldn't work as a plugin, but | don't want to have to spend an inordinate amount of time to make the system usable. | also
suspect this would get used more than the LDAP integration would by the general populace.

#16 - 2009-02-12 17:45 - Eric Davis
Jean-Philippe Lang wrote:
I'm pretty sad to see that this feature got integrated into the core.
IMHO, it's a marginal feature. Adding dependencies and bundling gems in vendor/plugins doesn't make the application easier to maintain.
I'm sorry you feel that way. I've spoken to numerous people on IRC and in real life and every one of them agreed that it would be a great feature for
the core. Lowering the barrier to entry for new users makes the system as a whole easier to get started with.
That's exactly the kind of thing that I'd like to see implemented as a plugin. Eric, you made a great job on plugins, why didn't you give it a try ?

Having a plugable authentication would be a much better solution.

Frankly, the authentication code is all over the place and it wouldn't be possible to have a pluggable authentication without replacing a ton of core
code (thus the risk of large breaking bugs). While putting OpenlID in, | managed to clean up some of the code but it's still pretty messy in there. I'd be
happy to pull OpenlID out to a plugin once the core can support it as a plugin. I'd propose we revisit pulling OpenID (and other features you've
mentioned) out to plugins once the core has a stronger API to support them.
Kevin Menard wrote:
That's not to say that it couldn't work as a plugin, but | don't want to have to spend an inordinate amount of time to make the system usable. |
also suspect this would get used more than the LDAP integration would by the general populace.

I've seen the same, OpenlID is used more often in the public than LDAP (but LDAP is used more often on private intranets).

#17 - 2009-03-28 00:14 - Eric Davis

- Status changed from Resolved to Closed

Closing as fixed. This requires database changes so it's 0.9 only and doesn't need to be merged into 0.8.x.

#18 - 2021-12-15 02:25 - Go MAEDA
- Related to Feature #35755: Drop OpenlD support added
